const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class CompensationsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const compensations = await db.compensations.create(
      {
        id: data.id || undefined,

        base_pay: data.base_pay || null,
        pay_type: data.pay_type || null,
        pay_frequency: data.pay_frequency || null,
        currency: data.currency || null,
        effective_date: data.effective_date || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await compensations.setEmployee(data.employee || null, {
      transaction,
    });

    await compensations.setOrganizations(data.organizations || null, {
      transaction,
    });

    return compensations;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const compensationsData = data.map((item, index) => ({
      id: item.id || undefined,

      base_pay: item.base_pay || null,
      pay_type: item.pay_type || null,
      pay_frequency: item.pay_frequency || null,
      currency: item.currency || null,
      effective_date: item.effective_date || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const compensations = await db.compensations.bulkCreate(compensationsData, {
      transaction,
    });

    // For each item created, replace relation files

    return compensations;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const compensations = await db.compensations.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.base_pay !== undefined) updatePayload.base_pay = data.base_pay;

    if (data.pay_type !== undefined) updatePayload.pay_type = data.pay_type;

    if (data.pay_frequency !== undefined)
      updatePayload.pay_frequency = data.pay_frequency;

    if (data.currency !== undefined) updatePayload.currency = data.currency;

    if (data.effective_date !== undefined)
      updatePayload.effective_date = data.effective_date;

    updatePayload.updatedById = currentUser.id;

    await compensations.update(updatePayload, { transaction });

    if (data.employee !== undefined) {
      await compensations.setEmployee(
        data.employee,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await compensations.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return compensations;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const compensations = await db.compensations.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of compensations) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of compensations) {
        await record.destroy({ transaction });
      }
    });

    return compensations;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const compensations = await db.compensations.findByPk(id, options);

    await compensations.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await compensations.destroy({
      transaction,
    });

    return compensations;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const compensations = await db.compensations.findOne(
      { where },
      { transaction },
    );

    if (!compensations) {
      return compensations;
    }

    const output = compensations.get({ plain: true });

    output.employee = await compensations.getEmployee({
      transaction,
    });

    output.organizations = await compensations.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.employees,
        as: 'employee',

        where: filter.employee
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.employee
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  user: {
                    [Op.or]: filter.employee
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.currency) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('compensations', 'currency', filter.currency),
        };
      }

      if (filter.base_payRange) {
        const [start, end] = filter.base_payRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            base_pay: {
              ...where.base_pay,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            base_pay: {
              ...where.base_pay,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.effective_dateRange) {
        const [start, end] = filter.effective_dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            effective_date: {
              ...where.effective_date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            effective_date: {
              ...where.effective_date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.pay_type) {
        where = {
          ...where,
          pay_type: filter.pay_type,
        };
      }

      if (filter.pay_frequency) {
        where = {
          ...where,
          pay_frequency: filter.pay_frequency,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.compensations.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('compensations', 'base_pay', query),
        ],
      };
    }

    const records = await db.compensations.findAll({
      attributes: ['id', 'base_pay'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['base_pay', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.base_pay,
    }));
  }
};
